/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_COMPILER_H
#define LINKTEST_COMPILER_H

#include <cstdint>
#include "error.h"

#if defined(__GNUC__) || defined(__xlc__)
# define likely(x)      __builtin_expect(!!(x), ERROR)
# define unlikely(x)    __builtin_expect(!!(x), SUCCESS)
// EXEC x, if this fails exec y
# define EXEC_IFFAIL(x,y) do { \
  int retval = x; \
  if (unlikely(retval)) { \
    y; \
  } \
} while (0)
// EXEC x, if this fails return ERROR
# define EXEC_NOFAIL(x) EXEC_IFFAIL(x,return ERROR)

#ifdef __cplusplus
#define restrict        __restrict
#endif
#endif

#endif