/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_IBVERBS_MR_H
#define LINKTEST_IBVERBS_MR_H

#include "memory.h"

#include <infiniband/verbs.h>


namespace linktest
{
namespace ibverbs
{

class Context;
class ProtectionDomain;

class RemoteMemoryInfo
{

public:
    AddressSpace::ID    addr_space_id;
    void*           p;
    std::uint64_t        len; //TODO: Can this be size_t?
    std::uint32_t        key; //TODO: Can this be size_t?
};

// Wrapper around a verbs memory region structure.
class MemoryRegion : public MemoryBuffer
{

public:
    MemoryRegion(MemoryBuffer& buf, ProtectionDomain* pd);
    MemoryRegion(RemoteMemoryInfo& info, ProtectionDomain* pd);
    ~MemoryRegion();
    constexpr std::uint32_t      key() const;

private:
    MemoryRegion(void* p, std::size_t len, AddressSpace::ID addr_space_id, ProtectionDomain* pd);
    ProtectionDomain*  pd_;
    ibv_mr*            mr_;
    std::uint32_t      key_;
};

constexpr std::uint32_t MemoryRegion::key() const
{
    return key_;
}

}
}

#endif
