/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#include "config.h"
#include "compiler.h"
#include "error.h"
#include "ibverbs_pd.h"
#include "ibverbs_ctx.h"

#include <utility>
#include <stdexcept>


namespace linktest
{
namespace ibverbs
{

ProtectionDomain::ProtectionDomain(Context* ctx)
: ctx_(ctx), pd(nullptr)
{
    pd = ibv_alloc_pd(ctx_->ctx);
    if (unlikely(!pd)) {
        error("ibv_alloc_pd() failed");
        throw std::runtime_error("ibv_alloc_pd() failed");
    }
}

ProtectionDomain::~ProtectionDomain()
{
    auto ret = ibv_dealloc_pd(pd);
    if (unlikely(ret)) {
        error("ibv_dealloc_pd() failed");
    }
}

}
}
