/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_OUTPUT_SION_H
#define LINKTEST_OUTPUT_SION_H

#include "vcluster.h"
#ifdef USE_SION
	#include "sion_datatypes.h"
#endif

class VirtualCluster;
struct linktest_args;

/* Gather the local data in a buffer that can be written out using the
 * SION library.
 */
int linktest_output_sion_collect_local_data(VirtualCluster* cl,
                                            const struct linktest_args *args,
                                            const std::vector<LinktestStats>& statsVec,
                                            char **buffer,
                                            long long *sz);

/* Write using SIONlib. The output is funnelled through the root processing
 * element.
 */
int linktest_output_sion_funnelled(VirtualCluster* cl,
                                  const struct linktest_args *args,
                                  const std::vector<LinktestStats>& statsVec);

/* Write in parallel using SIONlib generic API with the same transport layer as the VirtualCluster
 */
int linktest_output_sion_parallel(VirtualCluster* cl,
                                  const struct linktest_args *args,
                                  const std::vector<LinktestStats>& statsVec);


#endif
