/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_PMI_H
#define LINKTEST_PMI_H

#if 1 == HAVE_MINIPMI
    struct minipmi_context;
#else
    struct minipmi_context
    {
        char    dummy;
    };
#endif

/* Borrow a reference to the singleton minipmi context. This function will
 * implicitly call PMI_Init() when returning the first reference.
 */
int linktest_minipmi_context_borrow(struct minipmi_context **pmictx);

/* Return a borrowed reference. If the reference count is zero PMI_Finalize()
 * is called.
 */
int linktest_minipmi_context_return(struct minipmi_context *pmictx);

#endif
