/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_SLOW_PAIRS_H
#define LINKTEST_SLOW_PAIRS_H

#include<cstdlib>
#include<vector>
#include <memory>

class VirtualCluster;

/* Record of a slow communication pair kept for serial retesting.
 */
struct slow_pair {
    int from;
    int to;
    double time;
};

/* This function sorts for the N slowest connections in parallel using a binary tree.
 * The number of slowest connections to search for can be arbitrarily large up to
 * and including as large as all tested connections.
 */
int find_and_sort_slowest_connections(std::unique_ptr<VirtualCluster> &cl,
                                      std::size_t num_slowest,
                                      std::vector<int>         from,
                                      std::vector<int>           to,
                                      std::vector<double>      time,
                                      std::vector<int>   &slow_from,
                                      std::vector<int>   &slow_to,
                                      std::vector<double>&slow_time
                                     );
#endif
