/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#include "timing.h"
#include "format_units.h"
#include <cstdio>

void printTimingIfRoot(int rank, std::string step_name, duration_t seconds) {
    if(rank == 0) {
        std::fprintf(stderr, "timings[%03d] %-30s t=%ss\n",
                rank,
                step_name.c_str(),
                UnitPrefix::SI_prefix(seconds.count(), 10).get());
    }
}
