/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_VCLUSTER_PSM2_H
#define LINKTEST_VCLUSTER_PSM2_H

#include "vcluster.h"
#include <memory>

namespace linktest
{
namespace psm2
{

class VirtualClusterImpl;

}
}

// VirtualCluster implementation utilizing the PSM2 API.
class VirtualClusterPSM2 : public VirtualClusterWithHelper
{

public:
    VirtualClusterPSM2(const std::string& name);

private:
    std::unique_ptr<linktest::psm2::VirtualClusterImpl>  impl_;

public:
    int init() override;
    int finalize() override;

    int kpingpong(const int from, const int to, MemoryBuffer& buf, 
                          const int num_msg, double* const timing) override;

    int kUniDir(const int from, const int to,
                        MemoryBuffer& buf1, MemoryBuffer& buf2,
                        const int num_msg, double* const timing,
                        const bool doBarrier) override;
    int kUniDirMultiBuf(const int from,const int to,
                                MemoryBufferMulti& buf_multi, MemoryBuffer& buf2,
                                const int num_msg, double* const timing,
                                const bool doBarrier) override;
    int kUniDirLimitedMultiBuf(const int from,const int to,
                                       MemoryBufferMulti& buf_multi, MemoryBuffer& buf2,
                                       const int num_msg, double* const timing,
                                       const bool doBarrier) override;

private:
    int kpingpong_send(int other, MemoryBuffer& buf, int tag0);
    int kpingpong_recv(int other, MemoryBuffer& buf, int tag0);

};

#endif
