/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#ifndef LINKTEST_VCLUSTERADPATER_H
#define LINKTEST_VCLUSTERADPATER_H

#include "vcluster.h"

namespace VirtualClusterSionGenericAdapter {
    int create_lcg_cb(void **local_vcluster, void *vcluster, 
			  int grank, int gsize, 
			  int lrank, int lsize,
			  int filenumber, int numfiles
			  );
    int free_lcg_cb(void *local_commgroup);
    int barrier_cb(void * vcluster);
    int bcastr_cb(void * data, void * vcluster, int datatype, int nelem, int root);
    int gatherr_cb(void * indata, void * outdata, void * vcluster, int datatype, int nelem, int root);
    int gathervr_cb(void * indata, void * outdata, void * vcluster, int datatype, int * counter, int nelem, int root);
    int scatterr_cb(void * indata, void * outdata, void * vcluster, int datatype, int nelem, int root);
    int scattervr_cb(void * indata, void * outdata, void * vcluster, int datatype, int * counter, int nelem, int root);

    int global_rank(VirtualCluster& cl);
    int global_size(VirtualCluster& cl);
    int local_rank(VirtualCluster& cl);
    int local_size(VirtualCluster& cl);
};

#endif // LINKTEST_VCLUSTERADPATER_H