/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/
#include "vector_bool.h"
#include <sstream>
#include <ios>
#include<algorithm>

std::string VectorBool::toString(const std::vector<bool> boolVec) {
    std::stringstream ss;
    ss << "[";
    ss << std::boolalpha;
    for(bool b: boolVec) {
        ss << b << ",";
    }
    ss << "]";
    return ss.str();
}

std::vector<bool> VectorBool::fromString (const std::string str){
    if(str.front() != '[' || str.back() != ']') {
        throw std::invalid_argument(str + " needs to be a list such as [] and [1,0,1,1]");
    }
    std::stringstream values(str.substr(1, str.size() -1));
    std::string value;
    std::vector<bool> res;
    while(std::getline(values, value, ','))
    {
        std::stringstream boolStr;
        bool b;
        boolStr << value;
        boolStr >> b;
        res.push_back(b);
    }
    return res;
}