#!/bin/bash
#############################################################################
##  LinkTest                                                               ##
#############################################################################
##  Copyright (c) 2008-2021                                                ##
##  Forschungszentrum Juelich, Juelich Supercomputing Centre               ##
##                                                                         ##
##  See the file COPYRIGHT in the package base directory for details       ##
#############################################################################


# The example uses a system that supports MPI, TCP, UCX and IBVerbs.
# Minipmi is already installed in ~/.local

# Set-Up Environment
ml GCC ParaStationMPI SIONlib SciPy-Stack;

# Use locallly installed minipmi, needed since we build with UCX and IBVerbs support
export LIBRARY_PATH=$LIBRARY_PATH:~/.local/lib/;
export CPATH=$CPATH:~/.local/include/;

# Install linktest in folder install
mkdir -p install;
cd benchmark;
make clean
make -j 12 HAVE_TCP=1 HAVE_IBVERBS=1 HAVE_UCP=1 PREFIX=../install install;
make clean
cd ..;
# Install linktest-report
# FIX for JSC Systems 
#export CPATH=/p/software/<SYSTEM>/stages/2022/software/SciPy-bundle/2021.10-gcccoremkl-11.2.0-2021.4.0/lib/python3.9/site-packages/numpy/core/include:$CPATH
cd install;
python3 -m venv linktest-report-venv;
source linktest-report-venv/bin/activate
cd ../python;
python3 -m pip install .; #TODO: Add --use-feature=in-tree-build if using pip 21.0.X to 21.2.X (default from 21.3 onwards)
deactivate;
cd ..;
# Notice that we close the virtual environment, since this script is likely not sourced
# To use python-report one has to source linktest-report-venv/bin/activate again
# To uninstall: pip uninstall linktest, or remove the virtual environment completly
