#!/bin/bash
#############################################################################
##  LinkTest                                                               ##
#############################################################################
##  Copyright (c) 2008-2021                                                ##
##  Forschungszentrum Juelich, Juelich Supercomputing Centre               ##
##                                                                         ##
##  See the file COPYRIGHT in the package base directory for details       ##
#############################################################################


# The example uses a system that supports MPI, TCP, UCX and IBVerbs.
# Minipmi is already installed in ~/.local

# Set-Up Environment
ml GCC OpenMPI SciPy-Stack SIONlib;

# Install linktest in folder install
mkdir -p install_jedi;
cd benchmark;
make clean
make -j HAVE_SION=1 HAVE_TCP=0 HAVE_UCP=0 PREFIX=../install_jedi install;
cd ..;
# Install linktest-report
export CPATH=$EBROOTSCIPYMINBUNDLE/lib/python3*/site-packages/numpy/core/include:$CPATH
cd install_jedi;
python3 -m venv linktest-report-venv;
source linktest-report-venv/bin/activate
cd ../python;
python3 -m pip install .; #TODO: Add --use-feature=in-tree-build if using pip 21.0.X to 21.2.X (default from 21.3 onwards)
deactivate;
cd ..;
# Notice that we close the virtual environment, since this script is likely not sourced
# To use python-report one has to source linktest-report-venv/bin/activate again
# To uninstall: pip uninstall linktest, or remove the virtual environment completly
