/****************************************************************************
**  LinkTest                                                               **
*****************************************************************************
**  Copyright (c) 2008-2022                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <string.h>
#include <linux/limits.h>
#include <stdint.h>
#include "sion.h"
#include <Python.h>

#define NPY_NO_DEPRECATED_API NPY_1_7_API_VERSION
#include <numpy/arrayobject.h>

#define LIKELY(x)       __builtin_expect(!!(x), 1)
#define UNLIKELY(x)     __builtin_expect(!!(x), 0)

typedef int Version[3];

/**************/
/* Structures */
/**************/
struct SionFile{ //SION file properties
	FILE*     fp; //File pointer
	int32_t  sid; //SION file identifier
	int32_t size; //Number of ranks
};
struct Datetime{ //Introduced in version 2.1.6
	uint64_t   year; //Hopefully long enough for the foreseeable future
	uint8_t   month; //Month  (0-12)
	uint8_t     day; //Day    (0-31)
	uint8_t    hour; //Hour   (0-24)
	uint8_t  minute; //Minute (0-59)
	uint8_t  second; //Second (0-61)
};
